/*
 * Copyright (c) 2002-2006 JGoodies Karsten Lentzsch. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 *  o Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer. 
 *     
 *  o Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution. 
 *     
 *  o Neither the name of JGoodies Karsten Lentzsch nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission. 
 *     
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

package com.jgoodies.binding.tests;

import java.lang.reflect.InvocationTargetException;

import javax.swing.SwingUtilities;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;

import junit.framework.TestCase;

import com.jgoodies.binding.adapter.DocumentAdapter;
import com.jgoodies.binding.tests.value.ToUpperCaseStringHolder;
import com.jgoodies.binding.value.ValueHolder;
import com.jgoodies.binding.value.ValueModel;

/**
 * A test case for class {@link DocumentAdapter}.
 * 
 * @author  Karsten Lentzsch
 * @version $Revision: 1.8 $
 */
public final class DocumentAdapterTest extends TestCase {
    
    // Constructor Tests ******************************************************

    public void testConstructorRejectsNullParameters() {
        ValueModel subject = new ValueHolder();
        Document document  = new PlainDocument();
        try {
            new DocumentAdapter(null, document);
            fail("Constructor failed to reject null subject.");
        } catch (NullPointerException ex) {
            // The expected behavior
        }
        try {
            new DocumentAdapter(subject, null);
            fail("Constructor failed to reject null document.");
        } catch (NullPointerException ex) {
            // The expected behavior
        }
    }

    public void testConstructorLeavesSubjectUnchangedAndUpdatesDocument() {
        ValueModel subject  = new ValueHolder();
        Document document   = new PlainDocument();
        String subjectText  = "subjectText";
        String documentText = "documentText";
        Document adapter = createDefaultAdapter(subject, subjectText, document, documentText);
        assertEquals("The constructor must not change the subject value.",
                subjectText,
                subject.getValue());
        assertEquals("The constructor must update the document content.",
                subjectText,
                getDocumentText(document));
        assertEquals("The constructor must update the adapter content.",
                subjectText,
                getDocumentText(adapter));
    }

    
    // Synchronization ********************************************************
    
        
    public void testDocumentChangeUpdatesSubject() {
        ValueModel subject  = new ValueHolder();
        Document document   = new PlainDocument();
        String subjectText  = "subjectText";
        String documentText = "documentText";
        Document adapter = createDefaultAdapter(subject, subjectText, document, documentText);
        setDocumentText(adapter, "newDocumentText");
        assertEquals(
            "Failed to update the subject.",
            subject.getValue(),
            getDocumentText(adapter));
    }

    public void testDocumentChangeHonorsSubjectModifications() {
        final ValueModel subject  = new ToUpperCaseStringHolder();
        Document document   = new PlainDocument();
        String subjectText  = "subjectText";
        String documentText = "documentText";
        final Document adapter = createDefaultAdapter(subject, subjectText, document, documentText);
        setDocumentText(adapter, "newDocumentText");
        try {
            SwingUtilities.invokeAndWait(new Runnable() {
                public void run() {
                    assertEquals(
                        "Failed to honor the subject modifications.",
                        subject.getValue(),
                        getDocumentText(adapter));
                }
            });
        } catch (InterruptedException e) {
            e.printStackTrace();
        } catch (InvocationTargetException e) {
            e.printStackTrace();
        }
    }

    public void testSubjectChangeUpdatesDocument() {
        ValueModel subject  = new ValueHolder();
        Document document   = new PlainDocument();
        String subjectText  = "subjectText";
        String documentText = "documentText";
        Document adapter = createDefaultAdapter(subject, subjectText, document, documentText);
        subject.setValue("newSubjectText");
        assertEquals(
            "Failed to update the document.",
            subject.getValue(),
            getDocumentText(adapter));
    }
    

    // Helper Code ************************************************************
    
    private DocumentAdapter createDefaultAdapter(ValueModel subject, String initialSubjectText, Document document, String initialDocumentText) {
        subject.setValue(initialSubjectText);
        setDocumentText(document, initialDocumentText);
        return new DocumentAdapter(subject, document);
    }
    
    /**
     * Returns the text contained in the document.
     *
     * @param document   the document that holds the text
     * @return the text contained in the document
     * @see #setDocumentText(Document, String)
     */
    private String getDocumentText(Document document) {
        int length = document.getLength();
        try {
            return document.getText(0, length);
        } catch (BadLocationException e) {
            e.printStackTrace();
            return "";
        }
    }
    
    private void setDocumentText(Document document, String newText) {
        try {
            document.remove(0, document.getLength());
            document.insertString(0, newText, null);
        } catch (BadLocationException e) {
            // Should not happen in this context.
        }
    }

}
